// Datei: int.c
//
// Interruptroutine
//
// Holger Klabunde 
// 20.05.2002
// Compiler CC5x

#include "prozess.h"      // Der verwendete Prozessor
#include "protos.h"

#include <int16CXX.H>

#define RBUFLEN 32 //Gre des Empfangspuffers
unsigned char rbuf[RBUFLEN]; //Ringpuffer fr Empfang
//bank1 unsigned char rbuf[RBUFLEN]; //Ringpuffer fr Empfang in Bank1

unsigned char pos,rec;   //RS232 Empfang
unsigned char rpos,rcnt; //RS232 Empfang

unsigned char icnt,idat1,idat2;      //I2C-Empfang

unsigned char debounce; //Tastatur

#pragma origin 4  //Interruptvektor vom PIC

interrupt int_server( void)
{
//Alle wichtigen Register retten
 int_save_registers    // W, STATUS (and PCLATH)
 char sv_FSR = FSR;  // save FSR if required
                     //Neu in CC5x ! ging vorher automatisch

//###############################
//Beginn I2C-Interrupt
//###############################
 if(SSPIF)
  {
   if(DA_==0) icnt=0;  //Meine I2C-Adresse empfangen, dann Bytezhler auf 0

   rec=SSPBUF;      //Auf jeden Fall SSPBUF lesen
                    //BF wird dann automatisch zurckgesetzt

   if(icnt==1) idat1=rec; //1. Datenbyte abholen
   if(icnt==2) idat2=rec; //2. Datenbyte abholen
   icnt++;
   
   SSPOV=0;      //Sicherheitshalber Overflow Flag lschen
   SSPIF=0;      //Int Flag lschen, sonst Endlosinterrupt
  }
//###############################
//Ende I2C-Interrupt
//###############################


//###############################
//Beginn RS232-Empfangs-Interrupt
//###############################
 if(RCIF)
  {
//Routine von SDCC
	   /* don't overwrite chars already in buffer */
//	   if (rcnt < RBUFLEN)
//		   rbuf [(rpos+rcnt++) % RBUFLEN] = SBUF;

     rec=RCREG; //Daten auf jeden Fall abholen um RCIF zu lschen

     if(rcnt < RBUFLEN)
      {
       pos=rpos+rcnt;     //Ring Position im Array berechnen
       pos=pos % RBUFLEN; //Position auf jeden Fall im Array
       rcnt++;            //empfangene Bytes zhlen
       rbuf[pos] = rec; //Daten ins Array
      }
   //RCIF wird beim lesen von RCREG zurckgesetzt !
  }
//###############################
//Ende RS232-Empfangs-Interrupt
//###############################

//###############################
//Beginn Timer1-Interrupt
//###############################
 if(TMR1IF)
  {
   debounce++;
   if(debounce>3)
    {
     keys=(~PORTA)&0x3F; //Porta lesen, lowaktiv, sechs Tasten
     debounce=0;
    }
    
   TMR1IF=0; //Int-Flag lschen. Wichtig ! Sonst Endlosinterrupt
  }
//###############################
//Ende Timer1-Interrupt
//###############################

//Alle wichtigen Register wiederherstellen
 FSR = sv_FSR;       // restore FSR if saved
                     //Neu in CC5x ! ging vorher automatisch
 int_restore_registers // W, STATUS (and PCLATH)
}
